var grammar = 
'start = addsub;' +
'addsub = left:muldiv " "* op:("+"/"-") " "* right:addsub [ \\n\\r]* { return {type: "op", left: left, op: op, right: right }; } / muldiv;'+
'muldiv = left:primlitsym " "* op:("*"/"/") " "* right:muldiv { return {type: "op", left: left, op: op, right: right }; } / primlitsym;'+
'primlitsym = [ \\n\\r]* val:(float / int / string / symbol / object / lambda / "(" expr:addsub " "* ")" { return expr; }) { return val; };' +
'symbol = chars:[a-zA-Z_!?@]+ middle:[a-zA-Z_!?@0-9:]* trailing:[a-zA-Z_!?@0-9]* { return {type: "symbol", name: chars.join("") + middle.join("") + trailing.join("")}; };' +
'float = digits:[0-9]+ "." decimals:[0-9]+ { return {type: "floatlit", value: parseFloat(digits.join("") + "." + decimals.join("")) }; };' +
'int = digits:[0-9]+ { return {type: "intlit", value: parseInt(digits.join(""), 10)}; };' +
'string = "\\"" text:[^\\"]* "\\"" { return {type: "strlit", value: text.join("")}; };' +
'object = "#{" messages:assignment* "}" { return {type: "object", messages: messages}; };' +
'assignment = [ \\n\\r]* sym:symbol " "* "<-" expr:addsub { return {type: "assignment", symbol: sym, expression: expr}; }' +
'lambda = args:((& ":") argname+  )? "{" exprs:(assignment / addsub)* [ \\n\\r]* "}" { return {type: "lambda", args: args[1], expressions: exprs}; };' +
'argname = chars:[a-zA-Z_!?@:]+ trailing:[a-zA-Z_!?@0-9]* " "* { return {type: "symbol", name: chars.join("") + trailing.join("")}; };';
var parser = PEG.buildParser(grammar);

//var parser = PEG.buildParser('start = expr; expr = int; int = digits:[0-9]+ { return parseInt(digits.join(""), 10); }');

onReady(function() {
	q('input[type=button]').onclick = function() {
		var text = q('textarea').value;
		try {
			var parsed = parser.parse(text);
			q('div').innerHTML = text + "<br><br>" + JSON.stringify(parsed);
			console.log(parsed);
		} catch(e) {
			q('div').innerHTML = e.message + '<br>Line: ' + e.line + '<br>Col: ' + e.column;
		}
	}
});

